/* tslint:disable */
/* eslint-disable */
/**
 * opGUI - OpenAPI 3.0
 * Dummy description about the available endpoints Some useful links: - [The opGUI repository](https://gitlab.eclipse.org/eclipse/openpass/opgui) - [The documentation page](https://www.eclipse.org/openpass/content/html/index.html)
 *
 * The version of the OpenAPI document: 1.1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface Parameter
 */
export interface Parameter {
    /**
     * 
     * @type {string}
     * @memberof Parameter
     */
    id: string;
    /**
     * 
     * @type {string}
     * @memberof Parameter
     */
    type: ParameterTypeEnum;
    /**
     * 
     * @type {string}
     * @memberof Parameter
     */
    title: string;
    /**
     * 
     * @type {string}
     * @memberof Parameter
     */
    unit: string;
    /**
     * 
     * @type {string}
     * @memberof Parameter
     */
    value: string;
}


/**
 * @export
 */
export const ParameterTypeEnum = {
    Int: 'int',
    Bool: 'bool',
    Float: 'float',
    Double: 'double',
    String: 'string',
    IntVector: 'intVector',
    DoubleVector: 'doubleVector',
    BoolVector: 'boolVector',
    NormalDistribution: 'normalDistribution',
    LogNormalDistribution: 'logNormalDistribution',
    ExponentialDistribution: 'exponentialDistribution',
    UniformDistribution: 'uniformDistribution',
    GammaDistribution: 'gammaDistribution'
} as const;
export type ParameterTypeEnum = typeof ParameterTypeEnum[keyof typeof ParameterTypeEnum];


/**
 * Check if a given object implements the Parameter interface.
 */
export function instanceOfParameter(value: object): boolean {
    let isInstance = true;
    isInstance = isInstance && "id" in value;
    isInstance = isInstance && "type" in value;
    isInstance = isInstance && "title" in value;
    isInstance = isInstance && "unit" in value;
    isInstance = isInstance && "value" in value;

    return isInstance;
}

export function ParameterFromJSON(json: any): Parameter {
    return ParameterFromJSONTyped(json, false);
}

export function ParameterFromJSONTyped(json: any, ignoreDiscriminator: boolean): Parameter {
    if ((json === undefined) || (json === null)) {
        return json;
    }
    return {
        
        'id': json['id'],
        'type': json['type'],
        'title': json['title'],
        'unit': json['unit'],
        'value': json['value'],
    };
}

export function ParameterToJSON(value?: Parameter | null): any {
    if (value === undefined) {
        return undefined;
    }
    if (value === null) {
        return null;
    }
    return {
        
        'id': value.id,
        'type': value.type,
        'title': value.title,
        'unit': value.unit,
        'value': value.value,
    };
}

